///////////////////////////////////////////////////////////////////////////////
//
//  TCLIENT.PRG, 17:47 21.02.2023
//
//  Xb2.NET sample showing how to create a simple telnet client
//
//  Copyright (c) 2001-2015, Xb2.NET inc.
//  All rights reserved.
//
//  Author:   Boris Borzic
//  Email:    support@xb2.net
//  Web:      http://www.xb2.net
//
///////////////////////////////////////////////////////////////////////////////


     #include "dcdir.ch"
     #include "natmsg.ch"
     #include "appevent.ch"
     #include "xbp.ch"
     #include "dll.ch"
     #include "dccursor.ch"
     #Include "thread.ch"
     #include "class.ch"
     #include "dmlb.ch"
     #include "fileio.ch"
     #include "dctree.ch"
*    #include "SystemMetrics.ch"
*    #include "axcdxcmx.ch"  // 䨪 ActiveX
     #include "collat.ch"
     #include "common.ch"
     #include "dbedit.ch"
     #include "dbfdbe.ch"
     #include "dcapp.ch"
     #include "dcbitmap.ch"
     #include "dccargo.ch"
     #include "dcdialog.ch"
     #include "dcdir.ch"
     #include "dcfiles.ch"
     #include "dcgra.ch"
     #include "dcgraph.ch"        // 䨪
     #include "BdColors.Ch"       // 䨪
     #include "dccolors.ch"       // 䨪
     #include "dcprint.ch"        // 䨪
     #include "dcicon.ch"
     #include "dcmsg.ch"
     #include "dcpick.ch"
     #include "deldbe.ch"
     #include "dmlb.ch"
     #include "express.ch"
     #include "fileio.ch"
     #include "font.ch"
     #include "gra.ch"
     #include "inkey.ch"
     #include "memvar.ch"
     #include "prompt.ch"
     #include '_dcdbfil.ch'
     #include "set.ch"
     #include "std.ch"
     #include "xbp.ch"
     #include '_dcappe.ch'
     #include 'dcscope.ch'
     #include '_dcstru.ch'
     #include 'dcfields.ch'
     #include 'dccolor.ch'
     #include "Fileio.ch"    // Max_DB
     *#include "rmchart.ch"   // 䨪 ActiveX
     *#include "dcads.ch"
     
     #pragma library( "ascom10.lib" )
*    #pragma library( "dclip1.lib" )
*    #pragma library( "dclip2.lib" )
     #pragma library( "dclipx.lib" )
     #pragma library( "xbtbase1.lib" )
     #pragma library( "xbtbase2.lib" )
     #pragma library( "xppui2.lib" )
     #Pragma Library("Taskbar.lib")

     #include "directry.ch"                 // 2.0
     #pragma Library( "ASINet10.lib" )      // 2.0
     
     PROCEDURE AppSys
     //     
     RETURN


//-----------------------------------------------------------------------------
static procedure ParamHelp()
  ?
  ? "Xb2.NET sample telnet client"
  ?
  ? "Parameters:"
  ? "  /HOST:string  - Telnet server host name or IP address"
  ? "  /PORT:number  - Port number of remote Telnet server"
  ? "  /SSL          - Create secure connection when specified"
  ?
  ? "Example:"
  ? "  TCLIENT /HOST:127.0.0.1 /PORT:992 /SSL"
  ?
  inkey(0)
  quit
  Return

***********************************************************************************************************************************************************
*        TCP.         exe. 
*     TCP          . 
*    IP  127.0.0.1    23.                
*        .         . 
*         .     Hello AIDOS-X++!
***********************************************************************************************************************************************************

//-----------------------------------------------------------------------------
procedure Main()

   Local i, nKey, cSend, cRecv, oSock, cColor, cHost, cPort, lSecure, oSSLContext
   Local cParamLine := ""

   for i := 1 to pcount()
      cParamLine += pvalue(i) + " "
   next

   if "/?" $ cParamLine .or. "/HELP" $ cParamLine
      ParamHelp()
   endif

* ? "  TCLIENT /HOST:127.0.0.1 /PORT:992 /SSL"

   cHost  := GetParam("/HOST:", cParamLine)
   cPort  := GetParam("/PORT:", cParamLine)

   lSecure:= GetParam("/SSL"  , cParamLine) != NIL

   DEFAULT cHost TO "LocalHost"               // a server running on the same machine
   DEFAULT cPort TO iif(lSecure, "992","23")  // default port for Telnet


*  SET CURSOR ON

   if lSecure .and. (oSSLContext := GetSSLContext()) == NIL
      inkey(5)
      Return
   endif

*  ? "create socket..."
   oScr := DC_WaitOn("create socket...")

   oSock := xbSocket():New(AF_INET, SOCK_STREAM, IPPROTO_IP, oSSLContext)

   if oSock:ErrorCode > 0
      DC_Impl(oScr)                                                   
      MsgBox("Unable to create a socket!" + chr(10) +;
             "Error code: " + LTrim(Str(oSock:ErrorCode)) + " (" + oSock:ErrorMessage + ")" )
      Return
   endif
   DC_Impl(oScr)                                                   

*  ? "connect to server..."
   oScr := DC_WaitOn("connect to server...")

   if ! oSock:Connect(cHost, Val(cPort))
      MsgBox("Unable to connect to: " + cHost + chr(10) +;
             "Error code: " + LTrim(Str(oSock:ErrorCode)) + " (" + oSock:ErrorMessage + ")" )
      oSock:destroy()
      Return
   endif

   // turn off blocking mode so that :Send/:Recv don't wait
   oSock:SetBlockingMode(.f.)

   DC_Impl(oScr)                                                   

*  ?                 "connected to: ", oSock:RemoteName, ", address:", oSock:InetNtoA(oSock:RemoteAddr), ", port:", NTrim(oSock:RemotePort)

   MsgBox("connected to: " + oSock:RemoteName + ", address: " + oSock:InetNtoA(oSock:RemoteAddr) + ", port: " + NTrim(oSock:RemotePort))

   nKey := 1

   cSend1 = 'AidosN12345678Client1'+CHR(00)+'1234This is a message from the Eidos system to the 1st client'
   cSend2 = 'AidosN12345678Client2'+CHR(00)+'1234This is a message from the Eidos system to the 2st client'

   while nKey != K_ESC

      if nKey != 0

         if oSock:Send( cSend1 ) < 0
            ? "connection lost..."
            exit
         endif

         if oSock:Send( cSend2 ) < 0
            ? "connection lost..."
            exit
         endif

         oSock:destroy()
         Return NIL
      endif

      cRecv := oSock:Recv()

      do case
      case cRecv == NIL
         ? "connection lost..."
         exit

      case Empty(cRecv)
         nKey := inkey(0.1)
         if nKey > 0
            cSend := iif(nKey == K_ENTER, CRLF, chr(nKey))
            ?? cSend
         endif

      otherwise

*        SET CURSOR OFF
         nKey   := 0
*        cColor := SetColor("w/b")
*        ? cRecv
*        SetColor(cColor)
*        ?
*        SET CURSOR ON

*        LB_Warning(STR(cRecv))

      endcase

   end

   // DON'T FORGET TO DESTROY THE OBJECT !!
   oSock:destroy()

*  wait
   Return

//-----------------------------------------------------------------------------
static function GetParam( cTag, cString )
   Local i, cVal

        DC_IconDefault(1000)

        Xb2NetKey()

   cTag := upper(cTag)

   if (i := at(upper(cTag), upper(cString))) == 0
      Return nil
   endif

   cVal := SubStr(cString, i+len(cTag))

   if (i := at(" ", cVal)) == 0
      Return cVal
   endif

   Return left(cVal, i-1)

//-----------------------------------------------------------------------------
static function GetSSLContext()
   Local oError, bErrBlock, cColor, oSSLContext

   // Possible reasons why the OpenSSL library cannot be loaded include:
   // 1. Your Xb2NetKey is invalid or it does not include SSL support
   // 2. The OpenSSL LIB files: LIBSSL32.DLL and LIBEAY32.DLL cannot be found in the system path

   bErrBlock := ErrorBlock( {|x|break(x)})
   BEGIN SEQUENCE
      oSSLContext := xbSSLContext():new( SSL_v23_client )
      ? "Using SSL", oSSLContext:Version
      ?

   RECOVER USING oError
      cColor := SetColor("r+/n")
      ?
      ? "ERROR: Unable to create SSL context!"
      ? oError:Description
      ? "Do you have the OpenSSL library installed?"
      ?
      SetColor(cColor)

   ENDSEQUENCE
   ErrorBlock( bErrBlock )

   Return oSSLContext

     ***********************************************************************************************************************

     FUNCTION LB_Warning( message, ctitle )
     
       LOCAL aMsg := {}
     *  DEFAULT cTitle TO ''
       IF valtype(message) # 'A'
         aadd(aMsg,message)
       ELSE
         aMsg := message
       ENDIF
       IF LEN(ALLTRIM(cTitle)) > 0
          DC_MsgBox(10,10,aMsg,cTitle)
       ELSE
          DC_MsgBox(10,10,aMsg,'    "-++"')
       ENDIF
     
     RETURN NIL

     ***********************************************************************************************************************


******************************************************************************************
FUNCTION Xb2NetKey()
Return()    // <-- put your Xb2.NET license key here